__version__ = "0.0.21"
# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00__init__.ipynb.

# %% auto 0
__all__ = ['loadmod']

# %% ../nbs/00__init__.ipynb 3
from itertools import chain
from importlib import import_module
from types import ModuleType

def loadmod(mod: ModuleType):
    if hasattr(mod, '__all__'): return mod.__all__
    if got := getattr(mod, '__module__', 'ltyp'):        
        if got == 'abc': got = f'ltyp.{mod.__name__}'
        return loadmod(import_module(got))
    raise AttributeError(f"module {mod} has no attribute '__all__'")


# %% ../nbs/00__init__.ipynb 4
from ltyp import (
    atyp, 
    iter as imod, 
    bool as bmod, 
    nums as numm, 
    nans as nmod, 
    strs, 
    libs, 
    plot,
    imgs,
    arrs,
    pand,
    trch,
    data, 
    dims
)

from .atyp import *
from .iter import *
from .bool import *
from .nums import *
from .nans import *
from .strs import *
from .libs import *
from .plot import *
from .imgs import *
from .arrs import *
from .pand import *
from .trch import *
from .data import *
from .dims import *

# %% ../nbs/00__init__.ipynb 5
__all__ = sorted(set(chain(*[
    loadmod(mod) for mod in (
        atyp, imod, bmod, numm, nmod, imod, strs, 
        libs, plot, imgs, arrs, pand, trch, data, dims
    )
])))
