# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_libs.ipynb.

# %% auto 0
__all__ = ['moduleloader', 'modulespec', 'pathlike', 'sig', 'param', 'logger', 'ichain', 'iprod', 'ziplong', 'dictkeys',
           'dictvalues', 'dictitems', 'moduletype', 'wrappertype', 'builtinfunctype', 'trackbacktype', 'functiontype',
           'mapping', 'richtree', 'richtext', 'richcons', 'richprog', 'richtask', 'tqdmauto', 'typerapp']

# %% ../nbs/10_libs.ipynb 6
from os import PathLike

# %% ../nbs/10_libs.ipynb 8
from typing import Literal

# %% ../nbs/10_libs.ipynb 10
#| export


# %% ../nbs/10_libs.ipynb 12
from ptyp import Prototype, Opt, Not
from matr import (
    moduleloader as impload,
    modulespec as impspec,
    pathlike as plibpath,
    sig as inspect_sig, 
    param as inspect_param,
    logger as loglog,
    
    
    ichain as iterchain, 
    iprod as iterprod, 
    ziplong as iterziplong,
    
    dict_keys, 
    dict_values, 
    dict_items,
    
    moduletype as modtype,
    wrappertype as wraptype,
    builtinfunctype as bftype,
    trackbacktype as tracetype,
    functiontype as functype,
    mapping as maptype,
    
    richtree as richrichtree,
    richtext as richrichtext,
    richcons as richrichcons,
    richprog as richrichprog,
    richtask as richrichtask,
    tqdmauto as tqdmtqdmauto,
    typer as typetyper,
)

# %% ../nbs/10_libs.ipynb 14
from .iter import itertype

# %% ../nbs/10_libs.ipynb 16
@Prototype(impload)
class moduleloader: '''`importlib.Loader`''';

@Prototype(impspec)
class modulespec: '''`importlib.machinery.ModuleSpec`''';

# %% ../nbs/10_libs.ipynb 17
@Prototype(plibpath, PathLike)
class pathlike: '''`pathlib.Path` or `os.PathLike`''';

@Prototype(inspect_sig)
class sig: '''`inspect.Signature`''';

@Prototype(inspect_param)
class param: '''`inspect.Parameter`''';

@Prototype(loglog)
class logger: '''`logging.Logger`''';

@Prototype(iterchain)
class ichain: '''`itertools.chain`''';

@Prototype(iterprod)
class iprod: '''`itertools.product`''';

@Prototype(iterziplong)
class ziplong: '''`itertools.ziplongest`''';

@Prototype(dict_keys)
class dictkeys: '''`_collections_abc.dict_keys`''';

@Prototype(dict_values)
class dictvalues: '''`_collections_abc.dict_values`''';

@Prototype(dict_items)
class dictitems: '''`_collections_abc.dict_items`''';

# %% ../nbs/10_libs.ipynb 18
@Prototype(modtype)
class moduletype: '''`types.ModuleType`''';

@Prototype(wraptype)
class wrappertype: '''`types.MethodWrapperType`''';

@Prototype(bftype)
class builtinfunctype: '''`types.BuiltinFunctionType`''';

@Prototype(tracetype)
class trackbacktype: '''`types.TracebackType`''';

@Prototype(functype)
class functiontype: '''`types.FunctionType`''';

@Prototype(maptype)
class mapping: '''`collections.Mapping`''';

# %% ../nbs/10_libs.ipynb 20
@Prototype(richrichtree)
class richtree: '''`rich.tree.Tree`''';

@Prototype(richrichtext)
class richtext: '''`rich.text.Text`''';

@Prototype(richrichcons)
class richcons: '''`rich.console.Console`''';

@Prototype(richrichprog)
class richprog: '''`rich.progress.Progress`''';

@Prototype(richrichtask)
class richtask: '''`rich.tree.Task`''';

@Prototype(tqdmtqdmauto)
class tqdmauto: '''`tqdm.auto.tqdm`''';

@Prototype(typetyper)
class typerapp: '''`typer.Typer`''';
