# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/21_pand.ipynb.

# %% auto 0
__all__ = ['groupkey', 'pddelegate', 'pdindex', 'pdcatindex', 'boolindex', 'catindex', 'indextype', 'indexlike', 'pdseries',
           'seriestype', 'serieslike', 'serialized', 'dataframe']

# %% ../nbs/21_pand.ipynb 6
#| export


# %% ../nbs/21_pand.ipynb 8
from typing import TypeAlias

# %% ../nbs/21_pand.ipynb 10
#| export


# %% ../nbs/21_pand.ipynb 12
from ptyp import Prototype
from matr import (
    pdindex as pdpdindex,
    pdseries as pdpdseries,
    pdcatindex as pdpdcatindex,
    pddelegate as pdpddelegate,
    pddataframe as pdpddataframe,
)

# %% ../nbs/21_pand.ipynb 14
from .iter import itertype
from .bool import bool01, bools
from .nums import num, nums, numstr
from .arrs import nparray, recarray

# %% ../nbs/21_pand.ipynb 17
@Prototype(str, tuple, num, attrs=dict(dtype=numstr))
class groupkey: 
    '''groupby key (e.g. `str`, `tuple`, or `numstr`)'''

# %% ../nbs/21_pand.ipynb 18
@Prototype(pdpddelegate)
class pddelegate:
    '''`pandas.core.accessor.PandasDelegate`''';

# %% ../nbs/21_pand.ipynb 20
@Prototype(pdpdindex)
class pdindex:
    '''`pandas.Index`''';
    

@Prototype(pdpdcatindex)
class pdcatindex:
    '''`pandas.CategoricalIndex`''';

# %% ../nbs/21_pand.ipynb 22
@Prototype(bools, nparray, pdindex, list, attrs=dict(dtype=bool01))
class boolindex: '''boolean index'''

@Prototype(pdcatindex)
class catindex: '''categorical index'''

# %% ../nbs/21_pand.ipynb 23
@Prototype(pdindex, pdcatindex, boolindex)
class indextype: '''index types
    (e.g. `pd.Index`, `pd.CategoricalIndex`, or `boolindex`)'''

# %% ../nbs/21_pand.ipynb 25
@Prototype(list, tuple, bools, nums, itertype, pdindex, pdcatindex, boolindex, nparray)
class indexlike: '''index-like objects 
    (e.g. `list`, `tuple`,`bools`, `nums`, `itertype`, 
    `pd.Index`, `pd.CategoricalIndex`, `boolindex`, or `np.array`)'''

# %% ../nbs/21_pand.ipynb 27
@Prototype(pdpdseries)
class pdseries:
    '''`pandas.Series`''';

# %% ../nbs/21_pand.ipynb 29
@Prototype(pdseries, nparray, recarray, list, indexlike)
class seriestype: '''series type 
    (e.g. `pd.Series`, `np.array`, `np.recarray`, `list`, or `indexlike`)'''

@Prototype(seriestype)
class serieslike: '''series-like type'''

@Prototype(seriestype)
class serialized: '''serialized'''

# %% ../nbs/21_pand.ipynb 31
@Prototype(pdpddataframe)
class dataframe: '''`pandas.DataFrame`''';
